package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialVenue;
import org.springblade.modules.martial.service.IMartialVenueService;
import org.springframework.web.bind.annotation.*;

/**
 * 场地信息 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/venue")
@Tag(name = "场地信息管理", description = "场地信息接口")
public class MartialVenueController extends BladeController {

	private final IMartialVenueService venueService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialVenue> detail(@RequestParam Long id) {
		MartialVenue detail = venueService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialVenue>> list(MartialVenue venue, Query query) {
		IPage<MartialVenue> pages = venueService.page(Condition.getPage(query), Condition.getQueryWrapper(venue));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialVenue venue) {
		return R.status(venueService.saveOrUpdate(venue));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(venueService.removeByIds(Func.toLongList(ids)));
	}

}
